package algorithms.geneticAlgorithm.Components;

import java.util.Random;

public abstract class GAMutationStrategy<I extends GAIndividual> {
	
	protected double mutationProb;
	protected static Random rng = new Random();
	
	public GAMutationStrategy(double prob){
		mutationProb = prob;
	}
	
	public GAMutationStrategy(){
		mutationProb = 0.001;
		rng = new Random();
	}
	
	public abstract I mutateIndividual(I mutant);
	
	public void setMutationProbability(double probability){
		mutationProb = probability;
	}
	
	public double getMutationProbability(){
		return mutationProb;
	}

}
